;=== Defines
!define REG    `${SET}\HKLM.reg`
!define DEFREG `${DEFDATA}\settings\HKLM.reg`
;===
!define BMP    `${SET}\UserImages.bmp`
!define DEFBMP `${DEFDATA}\settings\UserImages.bmp`
;===
!define LANG   `HKEY_LOCAL_MACHINE\SOFTWARE\Nero\Nero 16\Nero16Suite\Shared`
!define KEY    FamilyLanguage
;===
!define LNK    `$EXEDIR\NeroExpressPortable.lnk`
!define ADV    `${APPDIR}\AdvrCntr6.dll`
;===
!define EXE    `${APPDIR}\nero.exe`
!define SENDTO `$SENDTO\${APP}.lnk`
;===
!define CLSID  `SOFTWARE\Classes\CLSID\{2A5C3003-DA89-4095-8DB0-6967946B4D9F}\InprocServer32`
;===
Function GetLCID
	!macro _GetLCID _LNG _LCID
		Push ${_LNG}
		Call GetLCID
		Pop ${_LCID}
	!macroend
	!define GetLCID `!insertmacro _GetLCID`
	Exch $0
	StrCmp $0 cs-CZ 0 +3
	StrCpy $0 1029
		Goto EndLCID
	StrCmp $0 da-DK 0 +3
	StrCpy $0 1030
		Goto EndLCID
	StrCmp $0 nl-NL 0 +3
	StrCpy $0 1043
		Goto EndLCID
	StrCmp $0 en-US 0 +3
	StrCpy $0 1033
		Goto EndLCID
	StrCmp $0 fi-FI 0 +3
	StrCpy $0 1035
		Goto EndLCID
	StrCmp $0 fr-FR 0 +3
	StrCpy $0 1036
		Goto EndLCID
	StrCmp $0 de-DE 0 +3
	StrCpy $0 1031
		Goto EndLCID
	StrCmp $0 el-GR 0 +3
	StrCpy $0 1032
		Goto EndLCID
	StrCmp $0 hu-HU 0 +3
	StrCpy $0 1038
		Goto EndLCID
	StrCmp $0 it-IT 0 +3
	StrCpy $0 1040
		Goto EndLCID
	StrCmp $0 ja-JP 0 +3
	StrCpy $0 1041
		Goto EndLCID
	StrCmp $0 ko-KR 0 +3
	StrCpy $0 1042
		Goto EndLCID
	StrCmp $0 nb-NO 0 +3
	StrCpy $0 1044
		Goto EndLCID
	StrCmp $0 pl-PL 0 +3
	StrCpy $0 1045
		Goto EndLCID
	StrCmp $0 pt-PT 0 +3
	StrCpy $0 2070
		Goto EndLCID
	StrCmp $0 pt-BR 0 +3
	StrCpy $0 1046
		Goto EndLCID
	StrCmp $0 ru-RU 0 +3
	StrCpy $0 1049
		Goto EndLCID
	StrCmp $0 es-ES 0 +3
	StrCpy $0 1034
		Goto EndLCID
	StrCmp $0 sv-SE 0 +3
	StrCpy $0 1053
		Goto EndLCID
	StrCmp $0 zh-CN 0 +3
	StrCpy $0 2052
		Goto EndLCID
	StrCmp $0 zh-TW 0 +3
	StrCpy $0 1028
		Goto EndLCID
	StrCmp $0 th-TH 0 +3
	StrCpy $0 1054
		Goto EndLCID
	StrCmp $0 tr-TR 0 +3
	StrCpy $0 1055
		Goto +2
	StrCpy $0 1033
	EndLCID:
	Exch $0
FunctionEnd
Function GetLNG
	!macro _GetLNG _LCID _LNG
		Push ${_LCID}
		Call GetLNG
		Pop ${_LNG}
	!macroend
	!define GetLNG `!insertmacro _GetLNG`
	Exch $0
	StrCmp $0 1029 0 +3
	StrCpy $0 cs-CZ
		Goto EndLNG
	StrCmp $0 1030 0 +3
	StrCpy $0 da-DK
		Goto EndLNG
	StrCmp $0 1043 0 +3
	StrCpy $0 nl-NL
		Goto EndLNG
	StrCmp $0 1033 0 +3
	StrCpy $0 en-US
		Goto EndLNG
	StrCmp $0 1035 0 +3
	StrCpy $0 fi-FI
		Goto EndLNG
	StrCmp $0 1036 0 +3
	StrCpy $0 fr-FR
		Goto EndLNG
	StrCmp $0 1031 0 +3
	StrCpy $0 de-DE
		Goto EndLNG
	StrCmp $0 1032 0 +3
	StrCpy $0 el-GR
		Goto EndLNG
	StrCmp $0 1038 0 +3
	StrCpy $0 hu-HU
		Goto EndLNG
	StrCmp $0 1040 0 +3
	StrCpy $0 it-IT
		Goto EndLNG
	StrCmp $0 1041 0 +3
	StrCpy $0 ja-JP
		Goto EndLNG
	StrCmp $0 1042 0 +3
	StrCpy $0 ko-KR
		Goto EndLNG
	StrCmp $0 1044 0 +3
	StrCpy $0 nb-NO
		Goto EndLNG
	StrCmp $0 1045 0 +3
	StrCpy $0 pl-PL
		Goto EndLNG
	StrCmp $0 2070 0 +3
	StrCpy $0 pt-PT
		Goto EndLNG
	StrCmp $0 1046 0 +3
	StrCpy $0 pt-BR
		Goto EndLNG
	StrCmp $0 1049 0 +3
	StrCpy $0 ru-RU
		Goto EndLNG
	StrCmp $0 1034 0 +3
	StrCpy $0 es-ES
		Goto EndLNG
	StrCmp $0 1053 0 +3
	StrCpy $0 sv-SE
		Goto EndLNG
	StrCmp $0 2052 0 +3
	StrCpy $0 zh-CN
		Goto EndLNG
	StrCmp $0 1028 0 +3
	StrCpy $0 zh-TW
		Goto EndLNG
	StrCmp $0 1054 0 +3
	StrCpy $0 th-TH
		Goto +2
	StrCpy $0 tr-TR
	EndLNG:
	Exch $0
FunctionEnd
Function ValidateLNG
	!macro _ValidateLNG _LCID _LNG
		Push ${_LCID}
		Call ValidateLNG
		Pop ${_LNG}
	!macroend
	!define ValidateLNG `!insertmacro _ValidateLNG`
	Exch $0
	StrCmp $0 Czech 0 +3
	StrCpy $0 cs-CZ
		Goto Validated
	StrCmp $0 Danish 0 +3
	StrCpy $0 da-DK
		Goto Validated
	StrCmp $0 Dutch 0 +3
	StrCpy $0 nl-NL
		Goto Validated
	StrCmp $0 English 0 +3
	StrCpy $0 en-US
		Goto Validated
	StrCmp $0 Finnish 0 +3
	StrCpy $0 fi-FI
		Goto Validated
	StrCmp $0 French 0 +3
	StrCpy $0 fr-FR
		Goto Validated
	StrCmp $0 German 0 +3
	StrCpy $0 de-DE
		Goto Validated
	StrCmp $0 Greek 0 +3
	StrCpy $0 el-GR
		Goto Validated
	StrCmp $0 Hungarian 0 +3
	StrCpy $0 hu-HU
		Goto Validated
	StrCmp $0 Italian 0 +3
	StrCpy $0 it-IT
		Goto Validated
	StrCmp $0 Japanese 0 +3
	StrCpy $0 ja-JP
		Goto Validated
	StrCmp $0 Korean 0 +3
	StrCpy $0 ko-KR
		Goto Validated
	StrCmp $0 Norwegian 0 +3
	StrCpy $0 nb-NO
		Goto Validated
	StrCmp $0 Polish 0 +3
	StrCpy $0 pl-PL
		Goto Validated
	StrCmp $0 Portuguese 0 +3
	StrCpy $0 pt-PT
		Goto Validated
	StrCmp $0 PortugueseBR 0 +3
	StrCpy $0 pt-BR
		Goto Validated
	StrCmp $0 Russian 0 +3
	StrCpy $0 ru-RU
		Goto Validated
	StrCmp $0 Spanish 0 +3
	StrCpy $0 es-ES
		Goto Validated
	StrCmp $0 Swedish 0 +3
	StrCpy $0 sv-SE
		Goto Validated
	StrCmp $0 SimpChinese 0 +3
	StrCpy $0 zh-CN
		Goto Validated
	StrCmp $0 TradChinese 0 +3
	StrCpy $0 zh-TW
		Goto Validated
	StrCmp $0 Thai 0 +3
	StrCpy $0 th-TH
		Goto Validated
	StrCmp $0 Turkish 0 +3
	StrCpy $0 tr-TR
		Goto +2
	StrCpy $0 error
	Validated:
	Exch $0
FunctionEnd
!define PortableApps.comLocaleID "!insertmacro PortableApps.comLocaleID"
!macro PortableApps.comLocaleID
	IfFileExists `${REG}` 0 +3
	ReadINIStr $0 `${REG}` `${LANG}` `"${KEY}"`
		Goto +2
	ReadINIStr $0 `${DEFREG}` `${LANG}` `"${KEY}"`
	${GetLCID} $0 $0
	${SetEnvironmentVariable} PortableApps.comLocaleID $0
!macroend
!define MsgBox "!insertmacro MsgBox"
!macro MsgBox
	StrCpy $0 `Windows XP +`
	MessageBox MB_ICONSTOP|MB_TOPMOST `$(MINREQ)`
	Call Unload
	Quit
!macroend
;=== Custom
${SegmentFile}
${Segment.OnInit}
	Push $0
	System::Call `${GETCURRPROC}`
	System::Call `${WOW}`
	StrCmp $0 0 0 +3
	${WriteSettings} 32 Architecture
		Goto +2
	${WriteSettings} 64 Architecture
	Pop $0
!macroend
;===
!macro ProExecInit
	StrCpy $ProgramExecutable BurningROM\Nero.exe
!macroend
;===
!macro OS
	Push $0
	${If} ${IsNT}
		${If} ${IsWinXP}
			${IfNot} ${AtLeastServicePack} 3
				StrCpy $0 `Service Pack 3`
				MessageBox MB_ICONSTOP|MB_TOPMOST `$(MINREQ)`
				Call Unload
				Quit
			${EndIf}
		${ElseIfNot} ${AtLeastWinXP}
			${MsgBox}
		${EndIf}
	${Else}
		${MsgBox}
	${EndIf}
	Pop $0
!macroend
;===
!macro Lang
	Push $0
	ClearErrors
	${ConfigReads} `${CONFIG}` Language= $0
	${IfNot} ${Errors}
	${AndIf} $0 != ""
		${ValidateLNG} $0 $0
		${If} $0 == error
			${PortableApps.comLocaleID}
		${Else}
			${GetLCID} $0 $0
			${SetEnvironmentVariable} PortableApps.comLocaleID $0
		${EndIf}
		WriteINIStr `${CONFIG}` ${APPNAME} Language ""
	${Else}
		${PortableApps.comLocaleID}
	${EndIf}
	Pop $0
!macroend
;===
!macro LangInit
	Push $0
	ReadEnvStr $0 PortableApps.comLocaleID
	${GetLNG} $0 $0
	${SetEnvironmentVariable} PAL:LanguageCustom $0
	Pop $0
!macroend
;===
!macro Init
	IfFileExists `${REG}` +2
	CopyFiles /SILENT `${DEFREG}` `${REG}`
	IfFileExists `${BMP}` +2
	CopyFiles /SILENT `${DEFBMP}` `${BMP}`
!macroend
;===
!macro PreDLL
	Push $0
	ClearErrors
	ReadRegStr $0 HKLM `${CLSID}` ""
	IfErrors +4
	${WriteRuntimeData} ${PAL} AdvrCntr6 `$0`
	UnRegDLL `$0`
	Pop $0
!macroend
;===
!macro PrePrimaryDLL
	RegDLL `${ADV}`
!macroend
;===
!macro PostPrimaryDLL
	UnRegDLL `${ADV}`
!macroend
;===
!macro UnloadDLL
	Push $0
	ClearErrors
	${ReadRuntimeData} $0 ${PAL} AdvrCntr6
	IfErrors +2
	RegDLL `$0`
	Pop $0
!macroend
;===
${SegmentPrePrimary}
	${File::BackupLocal} `${SENDTO}`
	CreateShortCut `${SENDTO}` `${EXE}` "" `${EXE}`
	CreateShortCut `${LNK}` `$EXEDIR\${APPNAME}.exe` "-w" `${EXE}`
!macroend
;===
${SegmentPostPrimary}
	${File::RestoreLocal} `${SENDTO}`
!macroend
;===
${SegmentUnload}
	Delete `$TEMP\*.tmp`
!macroend